# Demos and Tutorials

This section lists several demos that apply Concrete ML to some popular machine learning problems. They show how to build ML models that perform well under FHE constraints, and then how to perform the conversion to FHE.

Simpler tutorials that discuss only model usage and compilation are also available for [built-in models](/concrete-ml/1.1/built-in-models/ml_examples.md) and [deep learning](/concrete-ml/1.1/deep-learning/examples.md).

<table data-view="cards"><thead><tr><th></th><th></th><th></th><th data-hidden data-card-cover data-type="files"></th><th data-hidden data-card-target data-type="content-ref"></th></tr></thead><tbody><tr><td><strong>GPT-2 in FHE</strong></td><td>Privacy-preserving text generation based on a user's prompt</td><td></td><td><a href="/files/A7X3Y1wp7zS386PjuEqH">/files/A7X3Y1wp7zS386PjuEqH</a></td><td><a href="https://github.com/zama-ai/concrete-ml/blob/release/1.1.x/use_case_examples/llm/README.md">https://github.com/zama-ai/concrete-ml/blob/release/1.1.x/use_case_examples/llm/README.md</a></td></tr><tr><td><strong>Titanic</strong></td><td>Train an XGB classifier that can perform encrypted prediction for the <a href="https://www.kaggle.com/c/titanic/">Kaggle Titanic competition</a></td><td></td><td><a href="/files/ps3ALlJuWk5Jyf65ho9R">/files/ps3ALlJuWk5Jyf65ho9R</a></td><td><a href="https://github.com/zama-ai/concrete-ml/blob/release/1.1.x/use_case_examples/titanic/README.md">https://github.com/zama-ai/concrete-ml/blob/release/1.1.x/use_case_examples/titanic/README.md</a></td></tr><tr><td><strong>Neural Network Fine-tuning</strong></td><td>Fine-tune a VGG network to classify the CIFAR image data-sets and predict on encrypted data</td><td></td><td><a href="/files/S0EdqDioWCpVYB4jpsxm">/files/S0EdqDioWCpVYB4jpsxm</a></td><td><a href="https://github.com/zama-ai/concrete-ml/blob/release/1.1.x/use_case_examples/cifar_brevitas_finetuning/README.md">https://github.com/zama-ai/concrete-ml/blob/release/1.1.x/use_case_examples/cifar_brevitas_finetuning/README.md</a></td></tr><tr><td><strong>Neural Network Splitting for SaaS deployment</strong></td><td>Train a VGG-like CNN that classifies CIFAR10 encrypted images, and where an initial feature extractor is executed client-side</td><td></td><td><a href="/files/LrQfU8lVYojqi74eZi6J">/files/LrQfU8lVYojqi74eZi6J</a></td><td><a href="https://github.com/zama-ai/concrete-ml/blob/release/1.1.x/use_case_examples/cifar_brevitas_with_model_splitting/README.md">https://github.com/zama-ai/concrete-ml/blob/release/1.1.x/use_case_examples/cifar_brevitas_with_model_splitting/README.md</a></td></tr><tr><td><strong>Handwritten digit classification</strong></td><td>Train a neural network model to classify encrypted digit images from the MNIST data-set</td><td></td><td><a href="/files/V5kZBfalkQEZE5eBgLkW">/files/V5kZBfalkQEZE5eBgLkW</a></td><td><a href="https://github.com/zama-ai/concrete-ml/blob/release/1.1.x/use_case_examples/mnist/README.md">https://github.com/zama-ai/concrete-ml/blob/release/1.1.x/use_case_examples/mnist/README.md</a></td></tr><tr><td><strong>Encrypted Image filtering</strong></td><td>A Hugging Face space that applies a variety of image filters to encrypted images</td><td></td><td><a href="/files/9GCeIuoW2MOwiwqxjSCi">/files/9GCeIuoW2MOwiwqxjSCi</a></td><td><a href="https://github.com/zama-ai/concrete-ml/blob/release/1.1.x/use_case_examples/image_filtering/README.md">https://github.com/zama-ai/concrete-ml/blob/release/1.1.x/use_case_examples/image_filtering/README.md</a></td></tr><tr><td><strong>Encrypted sentiment analysis</strong></td><td>A Hugging Face space that securely analyzes the sentiment expressed in a short text</td><td></td><td><a href="/files/DdXOhksKk30Uhb7b1r1y">/files/DdXOhksKk30Uhb7b1r1y</a></td><td><a href="https://github.com/zama-ai/concrete-ml/blob/release/1.1.x/use_case_examples/sentiment_analysis_with_transformer/README.md">https://github.com/zama-ai/concrete-ml/blob/release/1.1.x/use_case_examples/sentiment_analysis_with_transformer/README.md</a></td></tr><tr><td><strong>Credit Scoring</strong></td><td>Predict the chance of a given loan applicant defaulting on loan repayment</td><td></td><td><a href="/files/3Xx1fx3lrIuReQHV6Uhb">/files/3Xx1fx3lrIuReQHV6Uhb</a></td><td><a href="https://github.com/zama-ai/concrete-ml/blob/release/1.1.x/use_case_examples/credit_scoring/README.md">https://github.com/zama-ai/concrete-ml/blob/release/1.1.x/use_case_examples/credit_scoring/README.md</a></td></tr><tr><td><strong>Healthcare diagnosis</strong></td><td>Give a diagnosis using FHE to preserve the privacy of the patient</td><td></td><td><a href="/files/raL9UBnBgl2bXPlE3GbS">/files/raL9UBnBgl2bXPlE3GbS</a></td><td><a href="https://github.com/zama-ai/concrete-ml/blob/release/1.1.x/use_case_examples/disease_prediction/README.md">https://github.com/zama-ai/concrete-ml/blob/release/1.1.x/use_case_examples/disease_prediction/README.md</a></td></tr></tbody></table>


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.zama.org/concrete-ml/1.1/getting-started/showcase.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
